#include <math.h>
#include "mlib.h"


double log_b(double x, double b){

     return log(x) / log(b);

}

/*	
  Ugly, unreconstructed, random number generators
*/



/*     RANDOM NUMBER GENERATORS: */

/*     RAN2(IDUM) RETURNS A UNIFORM RANDOM NUMBER ON (0,1). */
/*     THE ROUTINE IS FROM:  PRESS, W.H., B.P. FLANNERY, S.A. */
/*     TEUKOLSKY, AND W.T. VETTERLING.  1987.  NUMERICAL RECIPES. */
/*     CAMBRIDGE UNIVERSITY PRESS, CAMBRIDGE. */

double ran2(int * idum)
{
    /* Initialized data */

    static int m = 714025;
    static int ia = 1366;
    static int ic = 150889;
    static int iff = 0;

    /* System generated locals */
    double ret_val;

    /* Builtin functions */
    /* Subroutine */ int s_paus();

    /* Local variables */
    static int j, ir[97];
    static double rm;
    static int iy;

    rm = (double)1. / (double) m;
    if (*idum < 0 || iff == 0) {
	iff = 1;
	*idum = (ic - *idum) % m;
	for (j = 1; j <= 97; ++j) {
	    *idum = (ia * *idum + ic) % m;
	    ir[j - 1] = *idum;
/* L11: */
	}
	*idum = (ia * *idum + ic) % m;
	iy = *idum;
    }
    j = iy * 37 / m + 1;
    if (j > 97 || j < 1) {
/*	s_paus("", 0L); */
	exit(3);
    }
    iy = ir[j - 1];
    ret_val = iy * rm;
    *idum = (ia * *idum + ic) % m;
    ir[j - 1] = *idum;
    return ret_val;
} /* ran2_ */


/*     GAUSS(IDUM) RETURNS A NORMAL RANDOM NUMBER, X,S=(0,1). */
/*     THIS IS ROUTINE GASDEV(IDUM) FROM PRESS ET AL., ABOVE. */

double gauss(int * idum)
{
    /* Initialized data */

    static int iset = 0;

    /* System generated locals */
    double ret_val, r__1, r__2;

    /* Builtin functions */
    /* Local variables */
    static double gset, v1, v2, fac;
    static double sqpar, r;

    /* hack for resetting */
    if (*idum < 0)
	iset = 0;

    if (iset == 0) {
L21:
	v1 = ran2(idum) * 2.0 - 1.0;
	v2 = ran2(idum) * 2.0 - 1.0;
/* Computing 2nd power */
	r__1 = v1;
/* Computing 2nd power */
	r__2 = v2;
	r = (double) (r__1 * r__1 + r__2 * r__2);
	if (r >= 1.) {
	    goto L21;
	}
	sqpar = log(r) * -2.0 / r;
	fac = (float) sqrt(sqpar);
/*
	fac = sqrt(log(r) * (float)-2. / r);
*/
	gset = v1 * fac;
	ret_val = v2 * fac;
	iset = 1;
    } else {
	ret_val = gset;
	iset = 0;
    }
    return ret_val;
} /* gauss_ */

